/*
 * EditBox functions
 *
 *    $Id: Ctrl_EditBox.h,v 1.2 2006/11/08 23:48:01 jogi Exp $
 */

#ifndef __CTRL_EDITBOX_H__
#define __CTRL_EDITBOX_H__

#define MAX_EDITTEXT 255

typedef struct CEditBox_s
{
	char text[MAX_EDITTEXT+1];
	unsigned int width;
	unsigned int max;
	unsigned int pos;
	unsigned int disp;
} CEditBox;

void CEditBox_Init(CEditBox *e, int width, int max);
void CEditBox_Draw(CEditBox *e, int x, int y, qbool active);
void CEditBox_Key(CEditBox *e, int key);

#endif // __CTRL_EDITBOX_H__
