

#include "common.h"
#include "quakedef.h"

/*
	0:	axe
	1:	shotgun
	2:	nailgun
	3:	supershotgun
	4:	supernailgun
	5:	grenade launcher
	6:	rocket launcher
	7:	lightning gun

*/

float	accuracy[8];
int		kills[8],fired[8],hit[8];

cvar_t	weapon_info = {"weapon_info","0"};
cvar_t	weapon_info_x = {"weapon_info_x","50"};
cvar_t	weapon_info_y = {"weapon_info_y","50"};

void modinfo_f(void){
	int i;
	if (!strcmp(Cmd_Argv(1),"wp_info")){
		for (i=0;i<8;i++){
			//Com_Printf("%i %i %i\n",atoi(Cmd_Argv(2 + i*3)),atoi(Cmd_Argv(2 + i*3 + 1)),atoi(Cmd_Argv(2 + i*3 + 2)));
			fired[i]	=	atoi(Cmd_Argv(2 + i*3));
			hit[i]		=	atoi(Cmd_Argv(2 + i*3 +1));
			kills[i]	=	atoi(Cmd_Argv(2 + i*3 +2));
			if (hit[i] && fired[i])
				accuracy[i] = ((float)fired[i] / (float)hit[i])*100;
		}
		//Com_Printf("Weapon info read\n");
		return;
	}
	if (!strcmp(Cmd_Argv(1),"game_info")){
		Com_Printf("Weapon info\n");
		return;
	}

}

void modinfo_test_f(void){
	int x;
	for (x=0;x<8;x++){
		if (x==7)
			Com_Printf("%i %i %i\n",fired[x],hit[x],kills[x]);
		else
			Com_Printf("%i %i %i - ",fired[x],hit[x],kills[x]);
	}
}

void weapon_info_frame(void){
	int i,x,y;
	if (!weapon_info.value)
		return;
	x = (int) weapon_info_x.value;
	y = (int) weapon_info_y.value;
			Draw_ColoredString(x,y,"    Fired -  Hits - Kills - Effi",0);
	for (i=0;i<8;i++){
		Draw_ColoredString(x + 3,y + ((i+1)*8),va("    %5.5i - %5.5i - %5.5i - %5.5f",fired[i],hit[i],kills[i],accuracy[i]),0);
	}
}

// put his somewhere in cl_main.c in the CL_Init Function
void modinfo_init(void){
	Cvar_Register(&weapon_info);
	Cvar_Register(&weapon_info_x);
	Cvar_Register(&weapon_info_y);

	Cmd_AddCommand("modinfo",modinfo_f);
	Cmd_AddCommand("modinfo_test",modinfo_test_f);
}
