/*

	this analyzes the demo for good frags well i hope it will

*/

#include "quakedef.h"


typedef struct	da_s {
	vec3_t			angles;
	vec3_t			startpos;	// the position where the entity originated
	double			starttime;	// time the entity originated
	vec3_t			location;	// current location - will be endposition too
	double			stoptime;	// time the entitiy ceased to exist
	struct	da_s	*next;		// yep it will be a linked list :>
	int				done;		// simple check if this link has to be processed
	int				framecount;
	double			distance;
	double			disttowall;
	vec3_t			impact;
} da_t;

da_t	*da_rockets_start;

typedef	struct	da_points_s	{
	struct	da_points_s	*next;
	vec3_t				angles;
	vec3_t				position;
	vec3_t				velocity;


}	da_points_t;

typedef	struct	da_player_s {
	struct	da_player_s	*next;
	struct	da_points_s	*points;
	double				time;
	int					isdead;
} da_player_t;

da_player_t	*da_player_start;
da_player_t	*da_player_current;

typedef	struct	da_player_index_s {
	struct	da_player_s	*lines;
	struct	da_player_index_s	*next;
	char	name[128];
} da_player_index_t;

da_player_index_t	*da_players = NULL;

int		da_running;
int		old_fc;
int		run_first_time = 0;

qbool ON_Change_adf(cvar_t *var, char *string);


cvar_t	anal_draw	=	{"anal_draw","0"};
cvar_t	anal_draw_filter	=	{"anal_draw_filter","0",0,ON_Change_adf};
cvar_t	anal_selected_rocket=	{"anal_selected_rocket","0"};
cvar_t	anal_draw_distance_to_wall	=	{"anal_draw_distance_to_wall","0"};
cvar_t	anal_draw_viewvec	=	{"anal_draw_viewvec","0"};
cvar_t	anal_draw_viewvec_mult	=	{"anal_draw_viewvec_mult","0.5"};
cvar_t	anal_draw_player_all	=	{"anal_draw_player_all","0"};
cvar_t	anal_player		=	{"anal_player",""};

void CL_Play_f (void);

qbool ON_Change_adf(cvar_t *var, char *string){

	Cvar_Set(&anal_selected_rocket,"0");
	Cvar_Set(var,string);
	return true;

}

void DA_Frame(void){
	int i,found;
	da_t	*da_list;
	da_t	*da_hit;
	da_t	*da_current;
	da_player_t	*da_p_list;
	da_player_t	*da_p_current;
	da_points_t	*da_points_current;
	da_points_t	*da_points_list;
	da_player_index_t	*da_pi_list;
	da_player_index_t	*da_pi_current;
	extern int fps_count;


	return;

	if (!da_running)
		return;
	da_pi_list	=	da_players;
	if (da_pi_list->next == 0){
		for (i=0;i<32;i++){
			if (cl.players[i].name[0] && cl.players[i].spectator == 0){
					//da_pi_list = da_players;
					while (da_pi_list->next)
						da_pi_list = da_pi_list->next;
					da_pi_current = Q_malloc(sizeof(da_player_index_t));
					da_pi_current->lines = Q_malloc(sizeof(da_player_t));
					da_pi_current->lines->points = Q_malloc(sizeof(da_points_t));
					////strcpy(da_pi_current->name,cl.players[i].name);
					da_pi_list->next = da_pi_current ;
					Com_Printf("I should not be happening\n");
			}
		}
	}

	
	
	
	da_list	=	da_rockets_start;
	da_pi_list	=	da_players;
	da_p_list	=	da_player_start;
	// recording players
	while (da_pi_list){
		for (i=0;i<32;i++){
			if (!strcmp(cl.players[i].name,da_pi_list->name) && cl.players[i].spectator == 0){
				// lets find the latest active da_p_list
				da_p_list = da_pi_list->lines;
				while (da_p_list->next)
					da_p_list = da_p_list->next;
				// player died/slowspawns :>
				if (cl.players[i].stats[STAT_HEALTH] <= 0)
					da_p_list->isdead = 1;
				// player spawned so we start a new da_p
				if (da_p_list->isdead == 1 && cl.players[i].stats[STAT_HEALTH] > 0){
					//Com_Printf("I spawned !\n");
					da_p_current = Q_malloc(sizeof(da_player_t));
					da_p_list->next = da_p_current;
					da_p_list = da_p_current;
					da_p_list->isdead = 0;
					da_p_list->time = cls.demotime - demostarttime;
				}
				// if the player is dead we break
				if (da_p_list->isdead)
					break;
				//if non of the above we save his current state
				// search for the latest point
				da_points_list = da_p_list->points;
				if (da_points_list){
					while (da_points_list->next)
						da_points_list = da_points_list->next;
					da_points_current = Q_malloc(sizeof(da_points_t));
					da_points_list->next = da_points_current;
				}else{
					//Com_Printf("I should only be called when i spawn\n");
					da_p_list->points = Q_malloc(sizeof(da_points_t));
					da_points_current = da_p_list->points;
				}
				VectorCopy(cl.frames[cl.validsequence & UPDATE_MASK].playerstate[i].origin,da_points_current->position);
				VectorCopy(cl.frames[cl.validsequence & UPDATE_MASK].playerstate[i].viewangles,da_points_current->angles);
				VectorCopy(cl.frames[cl.validsequence & UPDATE_MASK].playerstate[i].velocity,da_points_current->velocity);
			}
		}
	da_pi_list = da_pi_list->next;
	}
	// recording all rockets
	for (i=0,found = 0;i<cl_visents.count;i++){
		if (!strcmp(cl_visents.list[i].model->name,"progs/missile.mdl")){ // || !strcmp(cl_visents.list[i].model->name,"progs/grenade.mdl")
			// lets look if our entity is registered !
			while (da_list){
					if (VectorCompare(cl_visents.list[i].angles,da_list->angles) && da_list->framecount == cls.framecount - 1){
						da_hit = da_list;
						found = 1;
						break;
					}
				da_list = da_list->next;
			}
			// if so ! lets update it 
			if (found){
				da_hit->framecount = cls.framecount;
				VectorCopy(cl_visents.list[i].origin,da_hit->location);
				da_hit->stoptime = cls.demotime - demostarttime;
			}else{
			// if not lets add it to the list
				da_list	=	da_rockets_start;
				while(da_list->next)
					da_list=da_list->next;
				da_current = Q_malloc(sizeof(da_t));
				da_list->next = da_current;
				VectorCopy(cl_visents.list[i].origin,da_current->startpos);
				VectorCopy(cl_visents.list[i].origin,da_current->location);
				VectorCopy(cl_visents.list[i].angles,da_current->angles);
				da_current->starttime = cls.demotime - demostarttime;
				da_current->stoptime = cls.demotime - demostarttime;
				da_current->framecount = cls.framecount;
				da_current->distance = 0;
				da_current->disttowall = 0;
			}
		}
	}
}

void DA_Print_Stats(void){
	int i = 0;
	da_t	*da_list;
	da_list = da_rockets_start;
	while (da_list){
		if (((da_list->distance > anal_draw_filter.value) && anal_draw_filter.value) || ((da_list->disttowall > anal_draw_distance_to_wall.value) && anal_draw_distance_to_wall.value && da_list->distance > 0)){
			if (i == anal_selected_rocket.value){
				Com_Printf("\n");
				Com_Printf("Starttime : %f\n",da_list->starttime);
				Com_Printf("Stoptime  : %f\n",da_list->stoptime);
				Com_Printf("Distance  : %f\n",da_list->distance);
				Com_Printf("\n");
			}
			i++;
		}
		da_list=da_list->next;
	}
	Com_Printf("oh mymy :D %i\n",i);
	

}

void DA_Print_Player(void){

	da_player_index_t	*da_pi_list;
//	da_player_index_t	*da_pi_current;
	da_pi_list	=	da_players;
	while (da_pi_list){
		Com_Printf("Test %s\n",da_pi_list->name);
		da_pi_list = da_pi_list->next;
	}
	

}
float MVD_TraceLine (const vec3_t start, const vec3_t end, vec3_t impact, vec3_t normal, int contents, int hitbmodels, entity_t *hitent);
void DA_Render_All_Rockets(void){
	extern cvar_t beziers_color_ca;
	vec3_t impact, normal, dest, origin,angles,lookatpoint;
	int i = 0;
	int z = 0;
	da_t	*da_list;
	entity_t	test;
	da_player_t	*da_p_list;
	da_points_t	*da_points_list;
	da_player_index_t	*da_pi_list;
	
	if (da_running)
		return;

	if (!anal_draw.value)
		return;

	//Com_Printf("Test\n");

	da_p_list	=	da_player_start;
	da_list = da_rockets_start;
	da_pi_list = da_players;
	i = 0;
	z=0;

	while (da_pi_list){
		da_p_list = da_pi_list->lines;
		while (da_p_list){
			da_points_list = da_p_list->points;
			if (da_p_list->next){
				if (((da_p_list->time < cls.demotime - demostarttime) && ( da_p_list->next->time > cls.demotime - demostarttime) && !strlen(anal_player.string) || anal_draw_player_all.value || strlen(anal_player.string) && !strcmp(da_pi_list->name,anal_player.string))){
				while (da_points_list){
					glDisable(GL_TEXTURE_2D);
					glPointSize(5.0);
					glColor3f(1,0,0);
					glBegin(GL_POINTS);
						glVertex3fv(da_points_list->position);
					glEnd();

					if (da_points_list->next){
						glBegin(GL_LINES);
							glVertex3fv(da_points_list->position);
							glVertex3fv(da_points_list->next->position);
						glEnd();
					}
					if (anal_draw_viewvec.value){
						for (i=0;i<3;i++)
							lookatpoint[i] = da_points_list->position[i] + da_points_list->angles[i] * anal_draw_viewvec_mult.value;

						glColor3f(0,1,0);
						glBegin(GL_POINTS);
							glVertex3fv(lookatpoint);
						glEnd();
							
						glBegin(GL_LINES);
								glVertex3fv(da_points_list->position);
								glVertex3fv(lookatpoint);
						glEnd();
					}
					glFlush();

					glEnable(GL_TEXTURE_2D);
					da_points_list = da_points_list->next;
					}
				
				}
			}else{
				while (da_points_list){
					glDisable(GL_TEXTURE_2D);
					glPointSize(5.0);
					glColor3f(1,0,0);
					glBegin(GL_POINTS);
						glVertex3fv(da_points_list->position);
					glEnd();

					if (da_points_list->next){
						glBegin(GL_LINES);
							glVertex3fv(da_points_list->position);
							glVertex3fv(da_points_list->next->position);
						glEnd();
					}
					if (anal_draw_viewvec.value){
						for (i=0;i<3;i++)
							lookatpoint[i] = da_points_list->position[i] + da_points_list->angles[i] * anal_draw_viewvec_mult.value;

						glColor3f(0,1,0);
						glBegin(GL_POINTS);
							glVertex3fv(lookatpoint);
						glEnd();
							
						glBegin(GL_LINES);
								glVertex3fv(da_points_list->position);
								glVertex3fv(lookatpoint);
						glEnd();
					}

					glFlush();
					glEnable(GL_TEXTURE_2D);
					da_points_list = da_points_list->next;
					}
				
			}
			da_p_list	=	da_p_list->next;
		}
		da_pi_list = da_pi_list->next;
	}

	i=0;
	z=0;
	while (da_list){
		if (da_list->distance == 0)
			da_list->distance = sqrt(pow((da_list->location[0] - da_list->startpos[0]),2) + pow((da_list->location[1] - da_list->startpos[1]),2) + pow((da_list->location[2] - da_list->startpos[2]),2));
		if (anal_draw_distance_to_wall.value == 1 && da_list->disttowall == 0){
			
			VectorSubtract(da_list->location,da_list->startpos,angles);
			//AngleVectors (angles,forward, right, up);
			VectorCopy(da_list->location,origin);
			for (i=0;i<3;i++)
				dest[i] = da_list->location[i] + angles[i] * 1000;
			MVD_TraceLine (origin, dest, impact, normal, 0, 1, &test);
			/*
			if (!VectorCompare(dest, impact))
			{
				dest[0] = impact[0] + forward[0] * 8 + normal[0] * 4;
				dest[1] = impact[1] + forward[1] * 8 + normal[1] * 4;
				dest[2] = impact[2] + forward[2] * 8 + normal[2] * 4;
			}*/
			da_list->disttowall = sqrt(pow((da_list->location[0] - impact[0]),2) + pow((da_list->location[1] - impact[1]),2) + pow((da_list->location[2] - impact[2]),2));
			VectorCopy(impact,da_list->impact);
		}
		if (((da_list->distance > anal_draw_filter.value) && anal_draw_filter.value) || ((da_list->disttowall > anal_draw_distance_to_wall.value) && anal_draw_distance_to_wall.value && da_list->distance > 0)){
			glDisable(GL_TEXTURE_2D);

			//gl`Color3ubv(StringToRGB(beziers_color_ca.string));
			glColor3f(1,1,1);

			glPointSize(5.0);
			glColor3f(1,0,1);
			glBegin(GL_POINTS);
				glVertex3fv(da_list->startpos);
				glColor3f(1,0,0);
				glVertex3fv(da_list->location);
				glColor3f(0,1,0);
				glVertex3fv(da_list->impact);
			glEnd();
			glFlush();
			if (z == anal_selected_rocket.value)
				glColor3f(0,1,0);
			else
				glColor3f(1,1,1);
			glBegin(GL_LINES);
				glVertex3fv(da_list->startpos);
				glVertex3fv(da_list->location);
			glEnd();

			glColor3f(0,1,0);
			glBegin(GL_LINES);
				glVertex3fv(da_list->location);
				glVertex3fv(da_list->impact);
			glEnd();
			glFlush();
			glEnable(GL_TEXTURE_2D);
			z++;
			}
		da_list=da_list->next;
	}


}

void DA_Start_Demo(void){
	extern HWND dibwindow, subwindow;
	

	

	if (Cmd_Argc() != 2) {
		Com_Printf ("analdemo <demoname> : gets demo speeds\n");
		return;
	}
	ShowWindow(dibwindow,SW_MINIMIZE);
	CL_Play_f ();
	
	if (cls.state != ca_demostart)
		return;
	
	cls.timedemo = true;
	return;
	da_running = 1;
	
}


void DA_Init(void){

	Cmd_AddCommand("anal_demo",DA_Start_Demo);			// i like fecal humor :>
	Cmd_AddCommand("anal_print",DA_Print_Stats);
	Cmd_AddCommand("anal_player_print",DA_Print_Player);
	Cvar_Register(&anal_draw);
	Cvar_Register(&anal_draw_filter);
	Cvar_Register(&anal_selected_rocket);
	Cvar_Register(&anal_draw_distance_to_wall);
	Cvar_Register(&anal_draw_viewvec);
	Cvar_Register(&anal_draw_viewvec_mult);
	Cvar_Register(&anal_draw_player_all);
	Cvar_Register(&anal_player);

	da_rockets_start = Q_malloc(sizeof(da_t));
	da_player_start = Q_malloc(sizeof(da_player_t));
	da_player_start->points = Q_malloc(sizeof(da_points_t));
	da_players = Q_malloc(sizeof(da_player_index_t));
	da_players->lines = Q_malloc(sizeof(da_player_t));
	da_players->lines->points = Q_malloc(sizeof(da_points_t));

}



