/*

	Multiview with framebuffer objects

*/
#include "quakedef.h"
#include "gl_framebuffer.h"










mvd_cams_t mvd_cams[4];






void MVD_Cam_Set_Currentposition (void){
	int i;
	i = atoi(Cmd_Argv(1));
	if (!strcmp("enable",Cmd_Argv(2)))
		mvd_cams[i].enable = atoi(Cmd_Argv(3));
	else if (!strcmp("fps",Cmd_Argv(2)))
		mvd_cams[i].fps = atoi(Cmd_Argv(3));
	else if (!strcmp("track",Cmd_Argv(2))){
		strcpy(mvd_cams[i].track,Cmd_Argv(3));
	}else {
	VectorCopy(cl.frames[cl.validsequence & UPDATE_MASK].playerstate[cl.playernum].origin,mvd_cams[i].origin);
	VectorCopy(cl.frames[cl.validsequence & UPDATE_MASK].playerstate[cl.playernum].viewangles,mvd_cams[i].view);
	}
}


void Multiview_Init(void){
	Cmd_AddCommand("multiview_cam",MVD_Cam_Set_Currentposition);
}

